type controle
	private:
		key_state as ubyte ptr
		button_state as ubyte
		
		tecla (0 to MAX_TECLAS - 1) as integer
		last_tecla (0 to MAX_TECLAS - 1) as integer
		
		declare function botaoJoy (botoes as integer, i as integer) as integer
		
	public:
		mouse as coord3d
	
		eixo_x as single
		eixo_acc as single
		eixo_brk as single
		eixo_clu as single
	
		const as integer DOWN = 0
		const as integer PRESSED = 1
		const as integer K_UP = 0
		const as integer K_DOWN = 1
		const as integer K_LEFT = 2
		const as integer K_RIGHT = 3
		const as integer K_MARCHAUP = 4
		const as integer K_MARCHADOWN = 5
		const as integer K_ESCOLHE = 6
		const as integer K_RETORNA = 7
		const as integer K_PAUSA = 8
		const as integer K_CAMUP = 9
		const as integer K_CAMDOWN = 10
		const as integer K_CARUP = 11
		const as integer K_CARDOWN = 12
		const as integer K_HUD = 13
		const as integer K_LOD = 14
		const as integer K_MIRROR = 15
		const as integer K_REPLAY = 16
		const as integer K_MOD = 17
		const as integer K_MARCHA1 = 18
		const as integer K_MARCHA2 = 19
		const as integer K_MARCHA3 = 20
		const as integer K_MARCHA4 = 21
		const as integer K_LOOKL = 22
		const as integer K_LOOKR = 23
			
		declare function confereTecla (i as integer, estado as integer) as _bool_
		declare function confereBotao (i as integer, estado as integer) as _bool_
		declare sub atualiza
		declare sub esperaTecla
end type

dim shared kev as controle

'-----------------------------------------------------------------------
function controle.confereTecla (i as integer, estado as integer) as _bool_
	if (estado = DOWN) or (estado = PRESSED and last_tecla(i) = false) then
		return tecla(i)
	else
		return false
	end if
end function

function controle.confereBotao (i as integer, estado as integer) as _bool_
	if button_state and SDL_BUTTON(i) then
		if estado = PRESSED then
			'espera soltar
			while button_state and SDL_BUTTON(i)
				atualiza
			wend
		end if
		
		return true
	else
		return false
	end if
end function

sub controle.atualiza
	dim as integer i, botoes
	
	'copia estado anterior
	for i = 0 to MAX_TECLAS - 1
		last_tecla(i) = tecla(i)
	next
	
	'atualiza key state
	SDL_PumpEvents
	key_state = SDL_GetKeyState(NULL)
	
	'atualiza mouse
	dim as integer mouse_x, mouse_y	
	button_state = SDL_GetMouseState(@mouse_x, @mouse_y)
	
	mouse.x = mouse_x
	mouse.y = mouse_y
	
	'atualiza joystick fb
	if JOYSTICK_ON then
		getjoystick 0, botoes, eixo_x, eixo_clu, eixo_acc, eixo_brk
		
		'transforma -1/1 a 0/1
		eixo_acc = 1 - ((eixo_acc + 1) / 2)
		eixo_brk = 1 - ((eixo_brk + 1) / 2)
		eixo_clu = 1 - ((eixo_clu + 1) / 2)
		
		'saturao
		eixo_brk = edge(eixo_brk * 1.25, 0, 1)
		eixo_clu = edge(eixo_clu * 1.25, 0, 1)
	else
		botoes = 0
	end if
		
	'mapeia sdl para vetor interno
	tecla(K_UP)			= key_state[SDLK_UP] 'or (eixo_acc = 1)
	tecla(K_DOWN)		= key_state[SDLK_DOWN] 'or (eixo_brk = 1)
	tecla(K_MARCHAUP)	= key_state[SDLK_A] or botaoJoy(botoes, 4)
	tecla(K_MARCHADOWN)	= key_state[SDLK_Z] or botaoJoy(botoes, 5)
	tecla(K_MARCHA1)	= botaoJoy(botoes, 12)
	tecla(K_MARCHA2)	= botaoJoy(botoes, 13)
	tecla(K_MARCHA3)	= botaoJoy(botoes, 14)
	tecla(K_MARCHA4)	= botaoJoy(botoes, 15)		
	tecla(K_LEFT)		= key_state[SDLK_LEFT] 
	tecla(K_RIGHT)		= key_state[SDLK_RIGHT]
	tecla(K_ESCOLHE)	= key_state[SDLK_RETURN] or botaoJoy(botoes, 0)
	tecla(K_RETORNA)	= key_state[SDLK_ESCAPE] or botaoJoy(botoes, 1)
	tecla(K_PAUSA)		= key_state[SDLK_P] or key_state[SDLK_PAUSE]
	tecla(K_CAMUP)		= key_state[SDLK_PAGEUP] or botaoJoy(botoes, 3)
	tecla(K_CAMDOWN)	= key_state[SDLK_PAGEDOWN] or botaoJoy(botoes, 2)
	tecla(K_CARUP)		= key_state[SDLK_HOME]
	tecla(K_CARDOWN)	= key_state[SDLK_END]
	tecla(K_HUD)		= key_state[SDLK_F1]
	tecla(K_MIRROR)		= key_state[SDLK_F2]
	tecla(K_LOD)		= key_state[SDLK_F3]
	tecla(K_REPLAY)		= key_state[SDLK_F4] or key_state[SDLK_R]
	tecla(K_MOD)		= key_state[SDLK_LSHIFT] or key_state[SDLK_RSHIFT]
	tecla(K_LOOKL)		= key_state[SDLK_X] or botaoJoy(botoes, 7)
	tecla(K_LOOKR)		= key_state[SDLK_C] or botaoJoy(botoes, 6)
	
	'alternativas de navegao com joystick
	if JOYSTICK_ON then
		tecla(K_PAUSA) = tecla(K_ESCOLHE)
		tecla(K_LEFT) = tecla(K_LEFT) or (eixo_x = -1)
		tecla(K_RIGHT) = tecla(K_RIGHT) or (eixo_x = 1)
	end if
	
	'simula analgico com teclado
	if not JOYSTICK_ON then
		if tecla(K_LEFT) then
			eixo_x = edge(eixo_x - (0.05 * fps.getFator), -1, 1)
		elseif tecla(K_RIGHT) then
			eixo_x = edge(eixo_x + (0.05 * fps.getFator), -1, 1)
		else
			if eixo_x > 0 then eixo_x = edge(eixo_x - (0.10 * fps.getFator), 0, 1)
			if eixo_x < 0 then eixo_x = edge(eixo_x + (0.10 * fps.getFator), -1, 0)
		end if
	end if
		
	if not JOYSTICK_ON or (JOYSTICK_ON and not USE_Y_AXIS) then
		if tecla(K_DOWN) then
			eixo_brk = edge(eixo_brk + (0.1 * fps.getFator), 0, 1)
		else
			eixo_brk = edge(eixo_brk - (0.1 * fps.getFator), 0, 1)
		end if	
		
		if tecla(K_UP) then
			eixo_acc = edge(eixo_acc + (0.1 * fps.getFator), 0, 1)
		else
			eixo_acc = edge(eixo_acc - (0.1 * fps.getFator), 0, 1)
		end if	
	end if
end sub

sub controle.esperaTecla
	do
		'whatever
	loop until confereTecla(K_ESCOLHE, PRESSED) or confereTecla(K_RETORNA, PRESSED)
end sub

function controle.botaoJoy (botoes as integer, i as integer) as integer
	if (botoes and (1 shl i)) > 0 then
		return 1
	else
		return 0
	end if
end function
