type editorContainer
	private:
		road as vertexList
		road_width as integer
		escape_width as integer
		mensagem as string
	
		declare sub fim
		declare sub editor
		declare sub atualiza
		
		declare function curva_b (i as integer, t as double) as double
		declare function curva_p (i as integer, t as double) as coord3d
		declare sub geraCurva
	
	public:	
		declare sub inicio (arq as string)
		declare sub salva (arq as string, cenario as integer, aclive as integer)
		declare function getDefault (i as integer) as integer
		
		declare function to3D (byval q as coord3d) as coord3d
		declare function to2D (byval q as coord3d) as coord3d	
end type

dim shared editor as editorContainer

'***
sub editorContainer.inicio (arq as string)
	road.load arq
	
	'arquivo existe?
	if road.cont > 0 then
		dim v as roadVertex
		v = road.getVertex(0)
		
		road_width = v.roadWidth
		escape_width = v.escapeWidth(0)
	
	'assume defaults
	else
		road.seed = timer
		road.cenario = 0
		road.aclive = 1
		
		road_width = 8
		escape_width = 10
		
		'gera preset shape
		dim as coord3d c1, c2, c3, c4
		c1.x = -300
		c1.y = -250
		c2.x = 300
		c2.y = -250
		c3.x = 300
		c3.y = 250
		c4.x = -300
		c4.y = 250
				
		road.cp_cont = 4
		road.cp(1) = c1
		road.cp(2) = c2
		road.cp(3) = c3
		road.cp(4) = c4
	end if	
	
	SDL_ShowCursor SDL_ENABLE
	
	mensagem = "press ESC when done."
	atualiza
	editor
end sub

'***
sub editorContainer.salva (arq as string, cenario as integer, aclive as integer)
	if road.cp_cont > 2 then
		road.centraliza
		road.pathfinding
		
		road.cenario = cenario
		road.aclive = aclive		
		road.dump arq
	else
		print "editorContainer: track too short, not writing any data!"
	end if
end sub

'***
function editorContainer.getDefault (i as integer) as integer
	if i = 0 then
		return road.cenario
	elseif i = 1 then
		return road.aclive
	else
		return 0
	end if
end function

'***
sub editorContainer.fim
	SDL_ShowCursor SDL_DISABLE
end sub

'***
sub editorContainer.editor
	do
		kev.atualiza
		
		'reseta mensagens
		mensagem = ""
		
		'teclado
		if kev.confereTecla(kev.K_RETORNA, kev.PRESSED) then
			exit do
		
		elseif kev.confereTecla(kev.K_UP, kev.PRESSED) then
			'aumenta
			if kev.confereTecla(kev.K_MOD, kev.DOWN) then
				if escape_width < 15 then escape_width = escape_width + 1
				mensagem = "runoff width: " + str(escape_width)
			else
				if road_width < 15 then road_width = road_width + 1
				mensagem = "road width: " + str(road_width)
			end if
			
			atualiza
			
		elseif kev.confereTecla(kev.K_DOWN, kev.PRESSED) then
			'diminui
			if kev.confereTecla(kev.K_MOD, kev.DOWN) then
				if escape_width > 2 then escape_width = escape_width - 1
				mensagem = "runoff width: " + str(escape_width)
			else
				if road_width > 6 then road_width = road_width - 1
				mensagem = "road width: " + str(road_width)
			end if
			
			atualiza
		end if
		
		'mouse
		if kev.mouse.x > 0 then
			if kev.confereBotao(SDL_BUTTON_LEFT, kev.DOWN) then
				'em cima de outro ponto?
				dim i as integer
				dim as _bool_ acao = false
				
				for i = 1 to road.cp_cont
					dim ponto2d as coord3d
					ponto2d = to2D(road.cp(i))
					
					if abs(kev.mouse.x - ponto2d.x) < 8 and abs(kev.mouse.y - ponto2d.y) < 8 then
						'move
						mensagem = "drag the control point wherever you like"
						
						while kev.confereBotao(SDL_BUTTON_LEFT, kev.DOWN)
							kev.atualiza							
							road.cp(i) = to3D(kev.mouse)
												
							atualiza
							sleep 20
						wend
						
						mensagem = ""
						atualiza
						
						acao = true
						exit for
					end if
				next
				
				'insere novo
				if not acao and road.cp_cont < 61 then
					'dentro da pista?
					if road.encontra(to3D(kev.mouse)) > -1 then
						'insere no meio
						dim v as roadVertex
						v = road.getVertex(road.encontra(to3D(kev.mouse)))
						
						dim tmp as vertexList
						tmp = road
						tmp.cp_cont = road.cp_cont + 1
						
						dim as integer j = 0
						for i = 0 to road.cp_cont + 1						
							if i = v.cp_id then
								tmp.cp(i) = to3D(kev.mouse)
							else
								tmp.cp(i) = road.cp(j)
								j = j + 1
							end if
						next
						
						road = tmp
						
						mensagem = "spliced road section"
					else
						'insere no fim (DESATIVADO)
						mensagem = "place control points within a road section"
						
						'road.cp_cont = road.cp_cont + 1
						'road.cp(road.cp_cont) = to3D(kev.mouse)
					end if
					
					atualiza
				
					'espera soltar
					while kev.confereBotao(SDL_BUTTON_LEFT, kev.DOWN)
						kev.atualiza
						sleep 20
					wend
				end if
			
			elseif kev.confereBotao(SDL_BUTTON_RIGHT, kev.PRESSED) then
				'encontra ponto
				dim as integer i, p
				p = -1
				
				for i = 1 to road.cp_cont
					dim ponto2d as coord3d
					ponto2d = to2D(road.cp(i))
				
					if abs(kev.mouse.x - ponto2d.x) < 6 and abs(kev.mouse.y - ponto2d.y) < 6 then p = i
				next
				
				'remove
				if p > -1 and road.cp_cont > 3 then
					dim tmp as vertexList
					tmp = road
					tmp.cp_cont = road.cp_cont - 1
					
					dim as integer j = 0
					for i = 0 to road.cp_cont						
						if i <> p then
							tmp.cp(j) = road.cp(i)
							j = j + 1
						end if
					next
					
					road = tmp
					
					mensagem = "removed control point"
				elseif road.cp_cont <= 3 then
					mensagem = "too few control points to remove!"
				end if
				
				atualiza
			end if
		end if
		
		sleep 20
	loop

	fim
end sub

'***
sub editorContainer.atualiza
	'atualiza geometria
	road.cp(0) = road.cp(road.cp_cont)
	road.cp(road.cp_cont + 1) = road.cp(1)
	road.cp(road.cp_cont + 2) = road.cp(0)
	geraCurva
end sub

'***
function editorContainer.curva_b (i as integer, t as double) as double
	select case i
		case -2: return ((-t + 2) * t - 1) * t / 2
		case -1: return (((3 * t - 5) * t) * t + 2) / 2
		case 0: return ((-3 * t + 4) * t + 1) * t / 2
		case 1: return ((t - 1) * t * t) / 2
		case else: return 0
	end select
end function

'***
function editorContainer.curva_p (i as integer, t as double) as coord3d
	dim tmp as coord3d
	tmp.x = 0
	tmp.y = 0
	
	dim j as integer
	for j = -2 to 1
		tmp.x = tmp.x + curva_b(j, t) * road.cp(i + j).x
		tmp.y = tmp.y + curva_b(j, t) * road.cp(i + j).y
	next j
	
	return tmp
end function
  
'***
sub editorContainer.geraCurva
	dim as coord3d q, q_prev	
	dim as integer i, j
	
	'gera geometria
	road.nova
	
	for i = 2 to road.cp_cont + 1
		'pass 1: calcula distncia
		dim as double dist = 0
		
		q = curva_p(i, 0)
		for j = 1 to 10
			q_prev = q
			q = curva_p(i, j / 10)
						
			dist = dist + dist2p(q, q_prev)
		next j
		
		'determina resoluo
		dim as double res
		res = dist / 25 'esse  o fator da resoluo
		res = (5 * 0.3) + (res * 0.7) 'normaliza
		res = int(res)
	
		'pass 2: gera pontos
		for j = 1 to res
			q = curva_p(i, j / res)

			'adiciona vrtice
			dim as roadVertex v
			v.novo
			v.cp_id = i
			v.coord = q
			v.roadWidth = road_width
			v.escapeWidth(0) = escape_width
			v.escapeWidth(1) = escape_width
			road.add v		
		next j
	next i
	
	'limpa
	road.removeUltimo
	road.atualizaUltimo
	
	'faz grficos
	road.pintaEditor(mensagem)
end sub

'-----------------------------------------------------------------------
function editorContainer.to3D (byval q as coord3d) as coord3d
	'converso no eixo
	q.x = q.x - (w / 2)
	q.y = (h - q.y) - (h / 2)
	
	'converso 1024
	q.x = q.x / (h / 768)
	q.y = q.y / (h / 768)
	
	'magnificao
	q.x = q.x * FATOR_MAG
	q.y = q.y * FATOR_MAG
	
	q.z = 0
	return q
end function

'***
function editorContainer.to2D (byval q as coord3d) as coord3d
	'demagnificao
	q.x = q.x / FATOR_MAG
	q.y = q.y / FATOR_MAG
	
	'converso 1024
	q.x = q.x * (h / 768)
	q.y = q.y * (h / 768)
	
	'converso no eixo
	q.x = int(q.x + (w / 2))
	q.y = int(h - (q.y + (h / 2)))
	
	q.z = 0
	return q
end function
