type somBuffer
	public:
		snd as ALuint
	
		declare sub carrega (arquivo as string)
		declare sub destroi
end type

type somEngine
	private:
		voz (0 to MAX_CARROS + 1) as ALuint 'MAX_CARROS motor, +2 player skid/rumble
		efeito as ALuint
		
		declare function outOfRange (i as integer) as _bool_
		
	public:	
		declare sub cria
		declare sub destroi
		
		declare sub startYourEngines
		declare sub para
		
		declare sub toca (buf as somBuffer, p as coord3d, vol as ALfloat)
		declare sub defineVoz (i as integer, buf as somBuffer)
		declare sub setPos (i as integer, p as coord3d)
		declare sub setVelocity (i as integer, v as coord3d)
		declare sub setVolume (i as integer, vol as ALfloat)
		declare sub setPitch (i as integer, pitch as ALfloat)
		
		declare function getPlayer () as integer
end type

'-----------------------------------------------------------------------
sub somBuffer.carrega (arquivo as string)
	snd = alutCreateBufferFromFile(arquivo)
end sub

sub somBuffer.destroi
	alDeleteBuffers 1, @snd
end sub

'-----------------------------------------------------------------------
function somEngine.getPlayer () as integer
	return MAX_CARROS
end function

function somEngine.outOfRange (i as integer) as _bool_
	if i < 0 or i > MAX_CARROS + 1 then
		return true
	else
		return false
	end if
end function

sub somEngine.cria
	dim i as integer
	
	'cria sources
	alGenSources MAX_CARROS + 2, @voz(0)
	alGenSources 1, @efeito
	
	'define propriedades
	for i = 0 to MAX_CARROS + 1
		alSourcei voz(i), AL_LOOPING, AL_TRUE
		alSourcef voz(i), AL_PITCH, 1.0
		alSourcef voz(i), AL_GAIN, 1.0
		alSourcei voz(i), AL_REFERENCE_DISTANCE, 20
		alSourcei voz(i), AL_ROLLOFF_FACTOR, 0.95
	next i

	alSourcei efeito, AL_LOOPING, AL_FALSE
	alSourcei efeito, AL_PITCH, 1.0
	alSourcei efeito, AL_GAIN, 1.0
	alSourcei efeito, AL_REFERENCE_DISTANCE, 20
	alSourcei efeito, AL_ROLLOFF_FACTOR, 0.95
end sub

sub somEngine.destroi
	dim i as integer
	
	'desliga buffers
	for i = 0 to MAX_CARROS + 1
		alSourcei voz(i), AL_BUFFER, NULL
	next
	
	alSourcei efeito, AL_BUFFER, NULL
	
	'remove sources
	alDeleteSources MAX_CARROS + 2, @voz(0)
	alDeleteSources 1, @efeito
end sub

sub somEngine.startYourEngines
	dim i as integer
	
	if not SFX_ON then exit sub
	
	for i = 0 to MAX_CARROS + 1
		alSourcePlay voz(i)
	next i
end sub

sub somEngine.para
	dim i as integer
	
	for i = 0 to MAX_CARROS + 1
		alSourceStop voz(i)
	next i
end sub

sub somEngine.toca (buf as somBuffer, p as coord3d, vol as ALfloat)
	'pode tocar?
	if not SFX_ON then exit sub

	'j est tocando?
	dim estado as ALenum
	
	alGetSourcei efeito, AL_SOURCE_STATE, @estado
	if not estado = AL_PLAYING then
		'define buffer
		alSourcei efeito, AL_BUFFER, buf.snd
		alSource3f efeito, AL_POSITION, p.x, p.y, p.z
		alSourcef efeito, AL_GAIN, vol
		
		'toca
		alSourcePlay efeito
	end if
end sub

sub somEngine.defineVoz (i as integer, buf as somBuffer)
	if outOfRange(i) then exit sub
	alSourcei voz(i), AL_BUFFER, buf.snd
end sub

sub somEngine.setPos (i as integer, p as coord3d)
	if outOfRange(i) then exit sub
	alSource3f voz(i), AL_POSITION, p.x, p.y, p.z
end sub

sub somEngine.setVelocity (i as integer, v as coord3d)
	if outOfRange(i) then exit sub
	alSource3f voz(i), AL_VELOCITY, v.x, v.y, v.z 
end sub

sub somEngine.setVolume (i as integer, vol as ALfloat)
	if outOfRange(i) then exit sub
	alSourcef voz(i), AL_GAIN, vol
end sub

sub somEngine.setPitch (i as integer, pitch as ALfloat)
	if outOfRange(i) then exit sub
	alSourcef voz(i), AL_PITCH, pitch
end sub
