'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
' Este arquivo contm: gerenciamento de arquivos, clculos com ngulos, macros teis.
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

#include "dir.bi"

#define _bool_ byte

const as _bool_ false = 0
const as _bool_ true = not false
const as double PI = 3.141596
const as integer MAX_FILES = 128

type fileList
	private:
		arq (0 to MAX_FILES - 1) as string
	
		cont as integer		'total de itens
		atual as integer	'ltimo acessado
		
	public:
		declare sub nova (s as string, default as string)
		declare function proxArquivo () as string
		declare function getArquivo (incremento as integer) as string
end type

type tabelaSeno
	public:
		seno (0 to 31) as single
		cosseno (0 to 31) as single
		
		declare sub gera
end type

declare function wrap (valor as double, limite_inf as double, limite_sup as double) as double
declare function edge (valor as double, limite_inf as double, limite_sup as double) as double
declare function angdif (ang1 as double, ang2 as double) as double
declare function angmed (ang1 as double, ang2 as double) as double
declare function toRad (ang as double) as double
declare function toGrau (ang as double) as double

dim shared tabs as tabelaSeno

'------------------------------------------------------------------------------------
'uma espcie de mdulo
function wrap (valor as double, limite_inf as double, limite_sup as double) as double
	while valor < limite_inf or valor > limite_sup
		if valor < limite_inf then valor = valor + (limite_sup - limite_inf)
		if valor > limite_sup then valor = valor - (limite_sup - limite_inf)
	wend
	
	return valor
end function

'trava o valor nos limites
function edge (valor as double, limite_inf as double, limite_sup as double) as double
	if valor < limite_inf then
		return limite_inf
	elseif valor > limite_sup then
		return limite_sup
	else
		return valor
	end if
end function

'calcula a distncia entre dois ngulos
function angdif (ang1 as double, ang2 as double) as double
	dim as double norma
	norma = abs(ang1 - ang2)
	
	if norma <= pi then return norma
	return (2 * pi) - norma
end function

'calcula a mdia circular entre dois ngulos
function angmed (ang1 as double, ang2 as double) as double
	return wrap(atan2(0.5 * (sin(ang1) + sin(ang2)), 0.5 * (cos(ang1) + cos(ang2))), 0, 2 * pi)
end function

'converte um ngulo de graus para radiano
function toRad (ang as double) as double
	return ang / 180 * pi
end function

'...e vice-versa
function toGrau (ang as double) as double
	return ang * 180 / pi
end function

'------------------------------------------------------------------------------------
sub fileList.nova (s as string, default as string)
	cont = 0
	atual = 0

	'configura pesquisa
	arq(cont) = dir(s, fbNormal)
	
	print "fileList: lendo '"; s; "'"
	
	'l arquivos
	while len(arq(cont)) > 0 and cont < (MAX_FILES - 1)
		print "'"; arq(cont); "'"
		if arq(cont) = default then atual = cont
		
		cont = cont + 1
		arq(cont) = dir
	wend
	
	'no achou nada?
	if cont = 0 then
		print "Arquivos vitais faltando. Encerrando..."
		end
	end if
end sub

function fileList.proxArquivo () as string
	return getArquivo(1)
end function

function fileList.getArquivo (incremento as integer) as string
	atual = atual + incremento
	if atual >= cont then atual = 0
	if atual < 0 then atual = cont - 1
	
	return arq(atual)
end function

'------------------------------------------------------------------------------------
sub tabelaSeno.gera
	dim as integer i
	
	'normal
	for i = 0 to 15
		seno(i) = sin(i * (pi / 8))
		cosseno(i) = cos(i * (pi / 8))
	next i
	
	'wrap
	for i = 16 to 31
		seno(i) = seno(i - 16)
		cosseno(i) = cosseno(i - 16)
	next i
end sub
